#!/usr/local/bin/perl

#use Date::Manip;
use Time::Local;

sub dataformat () {

    $site_type = uc(shift(@_));
    $site      = shift(@_);
    $year      = shift(@_);
    $month     = shift(@_);
    @dates_to_proc = @_;
    $ucsite = uc($site);
    my $i_mis = -999;
    my $f_mis = -99.9;
    my @month_of_data = ();

#==============================================================================
#    
#
#
#==============================================================================

    print STDOUT "Processing year $year month $month data\n\n";
    
    load_data ($site,$year,@dates_to_proc);    # Returns @data_array
    sort_data ($year,$month,@data_array);      # Returns @sorted_data
    fill_data ($year,$month,@sorted_data);     # Returns @filled_data
    @month_of_data = @filled_data;
    @filled_data = ();

#    print STDOUT "$_\n";
#    for (@month_of_data) {
#	print STDOUT "$_\n";
#	sleep 1;
#    }

#    print STDOUT "\n\n\n  `,,`  Begin writing data to file(s)  `,,`\n\n\n\n";

#######################################################
# Position of each quantity in the @month_of_data array
#
# 00  epoch
# 01  year
# 02  month
# 03  day
# 04  hour
# 05  minute
# 06  qc_dpsp
# 07  qc_upsp
# 08  qc_nip
# 09  qc_dif
# 10  qc_par
# 11  qc_dpir
# 12  qc_dpirc
# 13  qc_dpird
# 14  qc_upir
# 15  qc_upirc
# 16  qc_upird
# 17  qc_uvb
# 18  qc_temp
# 19  qc_rh
# 20  qc_ws
# 21  qc_wd
# 22  qc_pres
# 23  djd
# 24  znd
# 25  dpsp
# 26  upsp
# 27  direct
# 28  diffuse
# 29  par
# 30  dpir
# 31  dpirc
# 32  dpird
# 33  upir
# 34  upirc
# 35  upird
# 36  uvb
# 37  temp
# 38  rh
# 39  ws
# 40  wd
# 41  pres
# 42  std_dpsp
# 43  std_upsp
# 44  std_nip
# 45  std_spsp
# 46  std_par
# 47  std_dpir
# 48  std_upir
# 49  std_uvb
#
# Make sure all values with qc flags > 0 are set to missing
    foreach $line (@month_of_data) {
	my @flds = split /\s+/, $line;
	if ($flds[6]  != 0) {$flds[25] = -999; $flds[42] = -99.9;} # dpsp
	if ($flds[7]  != 0) {$flds[26] = -999; $flds[43] = -99.9;} # upsp
	if ($flds[8]  != 0) {$flds[27] = -999; $flds[44] = -99.9;} # nip
	if ($flds[9]  != 0) {$flds[28] = -999; $flds[45] = -99.9;} # dif
	if ($flds[10] != 0) {$flds[29] = -999; $flds[46] = -99.9;} # par
	if ($flds[11] != 0) {$flds[30] = -999; $flds[47] = -99.9;} # dpir
	if ($flds[12] != 0) {$flds[30] = -999; $flds[47] = -99.9;} # dpirc
	if ($flds[13] != 0) {$flds[30] = -999; $flds[47] = -99.9;} # dpird
	if ($flds[14] != 0) {$flds[33] = -999; $flds[48] = -99.9;} # upir
	if ($flds[15] != 0) {$flds[33] = -999; $flds[48] = -99.9;} # upirc
	if ($flds[16] != 0) {$flds[33] = -999; $flds[48] = -99.9;} # upird
	if ($flds[17] != 0) {$flds[36] = -999; $flds[49] = -99.9;} # uvb
	if ($flds[18] != 0) {$flds[37] = -999;} # temp
	if ($flds[19] != 0) {$flds[38] = -999;} # rh
	if ($flds[20] != 0) {$flds[39] = -999;} # ws
	if ($flds[21] != 0) {$flds[40] = -999;} # wd
	if ($flds[22] != 0) {$flds[41] = -999;} # pres
    }



    print STDOUT "\n\n\n  -----=====>  Begin writing data to file(s)  <=====-----\n\n\n\n";


#==============================================================================
#   Section below is for processing "Logical Record 0100"
#==============================================================================
    print STDOUT "First processing downwelling data from $ucsite $year$month\n\n";
    printf "%6s\n","*U0100";


# If values are within limits, round them.  Otherwise, set to missing.     
    foreach $line (@month_of_data) {
	my @flds = split /\s+/, $line;
	foreach $fld (qw/25 27 28 30 41/){
	    if (($flds[$fld] >= 0) && ($flds[$fld] < 1500)) {
		$flds[$fld] = int($flds[$fld] + 0.5);
	    } elsif (($flds[$fld] < 0) && ($flds[$fld] >= -100)) {
		$flds[$fld] = int($flds[$fld] - 0.5);
	    } else {
		$flds[$fld] = -999;
	    }
	}
	foreach $fld (qw/42 44 45 47/){
	    if  (($flds[$fld] < 0) && ($flds[$fld] >= -0.05)) {
		$flds[$fld] = 0;
	    }
	    if (($flds[$fld] < -10) || ($flds[$fld] > 500)) {
		$flds[$fld] = -99.9;
	    }
	}

	if (($flds[25] < -998) || ($flds[42] < -99)) {
	    $flds[25] = -999;
	    $flds[42] = -99.9;
	}
	if (($flds[27] < -998) || ($flds[44] < -99)) {
	    $flds[27] = -999;
	    $flds[44] = -99.9;
	}
	if (($flds[28] < -998) || ($flds[45] < -99)) {
	    $flds[28] = -999;
	    $flds[45] = -99.9;
	}
	if (($flds[30] < -998) || ($flds[47] < -99)) {
	    $flds[30] = -999;
	    $flds[47] = -99.9;
	}

	printf " %2d %4d   %4d %5.1f %4d %4d   %4d %5.1f %4d %4d\n",$flds[3],$flds[5],$flds[25],$flds[42],$i_mis,$i_mis,$flds[27],$flds[44],$i_mis,$i_mis;
	printf "           %4d %5.1f %4d %4d   %4d %5.1f %4d %4d    %5.1f %5.1f %4d\n",$flds[28],$flds[45],$i_mis,$i_mis,$flds[30],$flds[47],$i_mis,$i_mis,$f_mis,$f_mis,$flds[41];
    }


#==============================================================================
#   Section below is for processing "Logical Record 0500"
#==============================================================================
    print STDOUT "Now to process the UV-B $ucsite $year$month data\n\n";
    printf "%6s\n","*U0500";

    foreach $line (@month_of_data) {
	my @flds = split /\s+/, $line;

	foreach $fld (qw/36/){
	    if  (($flds[$fld] < 0) && ($flds[$fld] >= -0.05)) {
		$flds[$fld] = 0;
	    }
	    if (($flds[$fld] < -10) || ($flds[$fld] > 500)) {
		$flds[$fld] = -99.9;
	    }
	}
	printf " %2d %4d %5.1f %5.1f %5.1f %5.1f %5.1f %5.1f %5.1f %5.1f\n",$flds[3],$flds[5],$f_mis,$f_mis,$f_mis,$f_mis,$f_mis,$f_mis,$f_mis,$f_mis;
	printf "         %5.1f %5.1f %5.1f %5.1f %5.1f %5.1f %5.1f %5.1f %5.1f %5.1f %5.1f %5.1f\n",$flds[36],$f_mis,$f_mis,$f_mis,$f_mis,$f_mis,$f_mis,$f_mis,$f_mis,$f_mis,$f_mis,$f_mis;
    }


#==============================================================================
#   Section below is for processing "Logical Record 1100"
#==============================================================================
    if (($site eq "dra") || ($site eq "bon") || ($site eq "bos")) {
	print STDOUT "Now to process the Radiosonde $ucsite $year$month data\n\n";
	sonde_process ($site_type, $site, $year, $month);
    }


#==============================================================================
#   Section below is for processing "Logical Record 3010"
#==============================================================================
    print STDOUT "Now to process the reflected shortwave and upwelling longwave $ucsite $year$month data";
    printf "%6s\n","*U3010";

    foreach $line (@month_of_data) {
	my @flds = split /\s+/, $line;
	foreach $fld (qw/26 33/){
	    if (($flds[$fld] >= 0) && ($flds[$fld] < 1000)) {
		$flds[$fld] = int($flds[$fld] + 0.5);
	    } elsif (($flds[$fld] < 0) && ($flds[$fld] >= -100)) {
		$flds[$fld] = int($flds[$fld] - 0.5);
		if  (($flds[$fld] < 0) && ($flds[$fld] >= -0.05)) {
		    $flds[$fld] = 0;  # Set small neg values to zero
		}
	    } else {
		$flds[$fld] = -999;
	    }
	}
	foreach $fld (qw/37 38 43 48/){
	    if  (($flds[$fld] < 0) && ($flds[$fld] >= -0.05)) {
		$flds[$fld] = 0;
	    }
	    if (($flds[$fld] < -10) || ($flds[$fld] > 500)) {
		$flds[$fld] = -99.9;
	    }
	}

	if (($flds[26] < -998) || ($flds[43] < -99)) {
	    $flds[26] = -999;
	    $flds[43] = -99.9;
	}
	if (($flds[33] < -998) || ($flds[48] < -99)) {
	    $flds[33] = -999;
	    $flds[48] = -99.9;
	}

	printf " %2d %4d   %4d %5.1f %4d %4d   %4d %5.1f %4d %4d\n",$flds[3],$flds[5],$i_mis,$f_mis,$i_mis,$i_mis,$flds[26],$flds[43],$i_mis,$i_mis;
	printf "           %4d %5.1f %4d %4d   %4d %5.1f %4d %4d    %5.1f %5.1f\n",$i_mis,$f_mis,$i_mis,$i_mis,$flds[33],$flds[48],$i_mis,$i_mis,$flds[37],$flds[38];
    }

    print STDOUT "\n\n\n\n    --------------- Completed processing $ucsite $year$month data ---------------\n\n\n\n";
}  
1;


#==========================================================
# subroutine fill_data
#==========================================================
sub fill_data () {
    use Time::Local;
    my $year  = shift(@_);
    my $month = shift(@_);
    my @data_to_fill = (@_);
    my (@flds,$hour,$data_fill);
    my $im = -999;
    my $fm = -99.9;

    my $timeinc;
    my $yyyymm = sprintf "%4d%02d", $year,$month;
    if ($yyyymm >= 200901) {
	$timeinc = 60;
    } else {
	$timeinc = 180;
    }

    print STDOUT "\n\nFilling missing data with missing values...\n";

    @filled_data = ();
    my $nextmonth = $month + 1;
    my $nextyear  = $year;
    if ($nextmonth == 13) {
	$nextmonth = 1;
	$nextyear  = $nextyear + 1;
    }
    my $time_beg = timegm(0,0,0,1,$month-1,$year);
    my $time_end = timegm(0,0,0,1,$nextmonth-1,$nextyear);

    while ($time_beg < $time_end) {
	if (scalar(@data_to_fill) > 0) {
	    my @flds = split /\s+/, shift(@data_to_fill);

	    if ($time_beg == $flds[0]) {
		$data_fill = join(' ',@flds);
		push (@filled_data, $data_fill);
		$time_beg = $time_beg + $timeinc;			    
	    } else {
		while ($time_beg < $flds[0]) {
		    my ($s,$mn,$hr,$md,$mm,$yyyy,$wd,$yd,$is) = gmtime($time_beg);
		    $yyyy = $yyyy+1900;
		    $mm   = $mm + 1;
		    $mn = (($hr * 60) + $mn);
		    $data_fill = join(' ',$seconds,$yyyy,$mm,$md,$hr,$mn,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$fm,$im,$im,$im,$im,$im,$fm,$fm,$fm,$fm,$fm,$fm,$fm,$fm);
		    push (@filled_data, $data_fill);
		    $time_beg = $time_beg + $timeinc;	
		}
		$data_fill = join(' ',@flds);
		push (@filled_data, $data_fill);
		$time_beg = $time_beg + $timeinc;			    
	    }
	} else {
	    my ($s,$mn,$hr,$md,$mm,$yyyy,$wd,$yd,$is) = gmtime($time_beg);
	    $yyyy = $yyyy+1900;
	    $mm   = $mm + 1;
	    $mn = (($hr * 60) + $mn);
	    $data_fill = join(' ',$seconds,$yyyy,$mm,$md,$hr,$mn,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$im,$fm,$im,$im,$im,$im,$im,$fm,$fm,$fm,$fm,$fm,$fm,$fm,$fm);
	    push (@filled_data, $data_fill);
	    $time_beg = $time_beg + $timeinc;	
	}
    }
    return(@filled_data);
}
1;


#==========================================================
# subroutine sort_data
#==========================================================
sub sort_data () {
    my $year   = shift(@_);
    my $month  = int(shift(@_));
    my @data_to_sort_fill = (@_);
    my ($line,$fld);

    print STDOUT "\nRemoving data outside the year and month being processed...";
    my (@month_dat);
    foreach $line (@data_to_sort_fill) {
	my @flds = split /\s+/, $line;
	if ($flds[2] == $month) {
            $month_line = join(' ',@flds);
	    push (@month_dat, $month_line);
        }
    }
    print STDOUT "\n\nSorting the array, keeping only the unique times...";

    my @unique = ();
    @sorted_data = ();
    my %found = ();
#
#     index($_,' ') returns the position (starts at 0) that ' ' was found
#     substr($_, 0, ...) returns the "time-in-secs" (position 0 'til space)
#
    @unique = grep { not $found{substr($_,0,index($_,' '))}++ } @month_dat;
    @sorted_data = sort {$a <=> $b} @unique; 
    return(@sorted_data);
}
1;


#==========================================================
# subroutine load_data
#==========================================================
sub load_data () {
    use Date::Manip;
    use Time::Local;

    my $site  = shift(@_);
    my $year  = shift(@_);
    my @dates_to_proc = (@_);
    my $end_date = pop (@_);
    my (@list_of_files,$date,$day,$file,$yyyy);

    my $end_day   = substr($end_date, 6, 2);
    my $end_month = substr($end_date, 4, 2);
    my $end_year  = substr($end_date, 0, 4);
    my $time      = timegm(0,0,0,$end_day,$end_month-1,$end_year);
    $time  = $time + 86400;
    my ($sec,$min,$hour,$mday,$mon,$yyyy,$wday,$yday,$isd) = gmtime($time);

    my $mon         = $mon + 1;
    my $mday        = $mday;
    my $yyyy        = $yyyy + 1900;
    my $first_day = sprintf "%4d%2.2d%2.2d", $yyyy,$mon,$mday;
    push (@dates_to_proc, $first_day);

    print STDOUT "Loading all available data into one array.\n";
    print STDOUT "The date are time-shifted to conform to BSRN standards.\n\n";

    @array_of_files = ();
    foreach $date (@dates_to_proc) {
	$date =~ /(\d\d\d\d)(\d\d)(\d\d)/;
        my $yyyy = $1;
	my $mm   = $2;
	my $dd   = $3;
	my $doy  = &Date_DayOfYear($mm,$dd,$yyyy);
	my $tdy  = substr($yyyy,2,2);

  	my $ipath = "./Data/Rad_Files/";    
	my $file = sprintf "%3s%2.2d%3.3d.rad", $site, $tdy, $doy;
	my $pathfile = join('',$ipath, $file);
	push (@array_of_files, $pathfile);
    }

    @data_array = ();    
    foreach $file (@array_of_files) {
	if (-e "$file") {
	    print STDOUT "Reading $file\n";
	    open (FP, "cat $file |");
	    while (<FP>) {
		time_fix ($_);
		push (@data_array, $fixed_data);
	    }
	}
	close(FP);
    }
    return(@data_array);
}
1;	


#==========================================================
# subroutine sonde_process
#==========================================================
sub sonde_process {
    use Time::Local;    
    my $site_type = uc(shift(@_));
    my $site      = shift(@_);
    my $year      = shift(@_);
    my $month     = shift(@_);
    my $ozone     = -9.9;
    my ($line);

    my $ipath = "./Data/UpperAir/";

    @prev_day = (gmtime(timegm(0,0,0,1,$month-1,$year) - 86400))[5,4,3];
    $prev_day[0] += 1900;
    $prev_day[1]++;
    $prev_day = sprintf( "$ipath$site%04d%02d%02d", @prev_day );

#print STDOUT qq!>>>DEBUG sort(glob("$prev_day*.snd $ipath$site$year$month*.snd"))\n!;
    @sonde_files = sort(glob("$prev_day*.snd $ipath$site$year$month*.snd"));
    ## Remove all except for the last launch for the previous day.
    shift(@sonde_files)  while $sonde_files[1] =~ m/$prev_day/;
#print STDOUT qq!>>>DEBUG ==> @sonde_files\n!;

    if (scalar(@sonde_files) > 0) {
	printf "%6s\n","*U1100";
    }

    foreach $filename (@sonde_files) {
	print STDOUT "Reading sonde file $filename\n";
	my ($line,$t_launch,$time);
	my $day = substr($filename,-10,2);
	open (FP, "cat $filename |");
	my @file = <FP>;
	chomp (@file);
	my $line1 = shift(@file);
	my @flds1 = split /\s+/, $line1;  #Synoptic Time
	my $line2 = shift(@file);
	my @flds2 = split /\s+/, $line2;  #WMO, lat, lon, launch time
	my $line3 = shift(@file);
	my @flds3 = split /\s+/, $line3;  #Sig level info
	my $line4 = shift(@file);
	my @flds4 = split /\s+/, $line4;  #Station ID, Sonde type
	
	my $flag = "Y";
	my $cnt = 0;
	my $cmp = 2000;
	my $elapsed_secs = 0;
	foreach $line (@file) {
	    my @flds = split /\s+/, $line;
	    my ($time, $fld);
	    if ($flag eq "Y") {  #GETS THE INITIAL TIME IN SECS OF LAUNCH
		my $yy = int(substr($filename,-16,4));
		my $mm = int(substr($filename,-12,2));
		my $dd = int(substr($filename,-10,2));
		my $hh = int(substr($filename,-8,2));
		my $mn = int(substr($filename,-6,2));
		$basetime = timegm(0,$mn,$hh,$dd,$mm-1,$yy);
		$flag = "N";
	    } else { #Calcs elapsed secs of flight using height-baseheight
		if (($flds[3] - $flds2[6]) > 0) {
		    $elapsed_secs = 
			(int((($flds[3] - $flds2[6])/305)+0.5)*60); 
		} else {
		    $time = -999;
		}
	    }

	    my ($ss,$mn,$hr,$md,$mm,$yyyy,$wd,$yd,$isd) = 
		    gmtime($basetime + $elapsed_secs);

	    $mm++;
	    $yyyy += 1900;

	    my $tot_min = $hr*60 + $mn;

	    if ($flds[4] > 32000) {
		$flds[4] = -99.9;
	    } else {
		$flds[4] = ($flds[4]/10);
	    }
	    if ($flds[5] > 32000) {
		$flds[5] = -999.9;
	    } else {
		$flds[5] = ($flds[5]/10);
	    }
	    foreach $fld (qw/6 7/){
		if ($flds[$fld] > 999) {
		    $flds[$fld] = -99;
		} elsif ($flds[$fld] < 0) {
		    $flds[$fld] = int($flds[$fld] - 0.5);
		} else {
		    $flds[$fld] = int($flds[$fld] + 0.5);
		}
	    }	
	    
	    if (($flds[2] < $cmp) && ($mm == int($month)) && ($flds[3] != 32767)) {
		printf " %2d %4d   %4d %4d %5d %5.1f %6.1f %3d %3d %4.1f\n",$md, $tot_min, $cnt, $flds[2], $flds[3], $flds[4], $flds[5], $flds[6], $flds[7], $ozone;
		$cnt++;
		$cmp = $flds[2]
		}
	}
    }
}
1;


#==================================================================
# subroutine time_fix
#==================================================================
sub time_fix () {
    my ($line) = $_;
    chop ($line);
    my @flds = split /\s+/, $line;

    my $timeinc;
    my $yyyymm = sprintf "%4d%02d", $flds[1],$flds[2];
    if ($yyyymm >= 200901) {
	$timeinc = 60;
    } else {
	$timeinc = 180;
    }

    my $time = timegm(0,$flds[5],$flds[4],$flds[3],$flds[2]-1,$flds[1]);
    my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = 
	gmtime($time-$timeinc);

    $flds[5] = (($hour * 60) + $min);
    $flds[4] = $hour;
    $flds[3] = $mday;
    $flds[2] = $mon + 1;
    $flds[1] = $year + 1900;
    
    $fixed_data = join(' ', $time-$timeinc, @flds);
    return($fixed_data);
}
1;
