#!/usr/local/bin/perl
#
# header1.pl creates the header through section *0007.
#

sub header1 {
    
    $site_type = lc(shift(@_));
    $site  = shift(@_);    
    $year  = shift(@_);
    $month = shift(@_);
    my $yyyymm = sprintf"%4d%02d",$year,$month;
    @dates_to_proc = @_;

    $month = sprintf "%2d", $month;

# Open the header.txt for the site being processed
#    
    $infile = "./Header/$site\_header.txt";
    open(META_HEADER_FILE, $infile) or die "Can't open $infile: $!\n";
    @flds=<META_HEADER_FILE>;
    for(@flds) {chomp($_);}
    close(META_HEADER_FILE);
    
    ($sta_ID,
     $message_not_for_bsrn_database,
     $date_of_sta_descript_change,
     $surface_type,
     $topography_type,
     $sta_address,
     $sta_tel,
     $sta_fax,
     $sta_tcpip,
     $sta_email_address,
     $sta_lat,
     $sta_lon,
     $sta_alt,
     $SYNOP_ID,
     $date_of_horizon_change,
     $az_el_pairs_of_horizon_change,
     $date_of_sta_history_change,
     $method_est_cloud_amount,
     $method_est_cloud_base,
     $method_est_water_content,
     $method_est_aero_vert_dist,
     $method_est_water_vap_pres,
     $flags_if_the_above_five_are_measured)=@flds;
    
    ($q1,$q2,$q3,$q4,$q5,$q6,$q7,$q8) 
	= split /\s+/, $quantity_measured_ID_number;
    ($pr01,$pr02,$pr03,$pr04,$pr05,$pr06,$pr07,$pr08,$pr09,$pr10,$pr11) 
	= split /,/,$az_el_pairs_of_horizon_change;

#=====================================================================
# ID, year, month, etc (0001) - See H1_FORMAT at the end
#=====================================================================
#
# Determines the version number of the data
#
    my $file_ver = "./Tables/version";
    $version_of_data = 1;
    open(VF, $file_ver) or die "Can't open $file_ver: $!\n";
    while (<VF>) {
	chomp;
	next if /^\s*$/;     # Skip blank lines
	next if /^\s*\#/;    # Skip comment lines
	s/\#.*$//;           # Strip tag comment
	if (/^$site/) {
	    my @flds = split/\s+/, $_;
	    my ($start,$end) = split/-/,$flds[1];
	    if (($yyyymm >= $start) && ($yyyymm <= $end)) {
		$version_of_data++;
	    }
	}
    }
    close(VF);
    write;
#=====================================================================
# Site scientist information (0002) 
#=====================================================================
#
# Determines the correct station and deputy scientist
#
    my $sta = uc($site_type);
    my @scidep;
    $scidep[0] = "./Header/scientist_info";
    $scidep[1] = "./Header/deputy_info";
    
    my ($date_of_sci_change, $date_of_deputy_change);
    foreach my $file (@scidep) {
	my $sta_flag  = "N";
	my $date_flag = "N";
	my $cnt = 0;
	my (@info,$change_date);
	
	open(SI, $file) or die "Can't open $file: $!\n";
	while (<SI>) {
	    chomp;
	    next if /^\s*$/;     # Skip blank lines
	    next if /^\s*\#/;    # Skip comment lines
	    s/\#.*$//;           # Strip tag comment
	    
	    if ($cnt == 6) {  # Exits while loop once all info is read
		last;
	    }
	    
	    if (($sta_flag eq "Y") && ($date_flag eq "Y") && ($cnt < 6)) {
		push (@info, $_);    # Loading data from file
		$cnt++;
	    }
	    
	    if ((/^\d\d\d\d\d\d/) && ($sta_flag eq "Y")) {
		if ($yyyymm >= $_) {     # Sets station date info
		    $change_date = $_;
		    $date_flag = "Y";
		}
	    }
	    
	    if (/^$sta/) {  # Sets a flag once "station" is found in file
		$sta_flag = "Y"
		}
	}
	
	if ($file =~ /scientist/) {
	    if ($yyyymm != $change_date) {
		@date_of_sci_change = (-1,-1,-1);
	    } else {
		@date_of_sci_change = (1,0,0);
	    }
	    
	    printf "*U0002\n";
	    printf " %2d %2d %2d\n",@date_of_sci_change;
	    printf "%-38s %-20s %-20.20s\n", @info[0..2]; # Name, Phone, Fax
	    printf "%-15s %-50.50s\n", @info[3..4];       # TCPIP, email
	    printf "%-80.80s\n", $info[5];                # Address
	} else {
	    if ($yyyymm != $change_date) {
		@date_of_deputy_change = (-1,-1,-1);
	    } else {
		@date_of_deputy_change = (1,0,0);
	    }
	    printf " %2d %2d %2d\n", @date_of_deputy_change;
	    printf "%-38s %-20s %-20.20s\n", @info[0..2]; # Name, Phone, Fax
	    printf "%-15s %-50.50s\n", @info[3..4];       # TCPIP, email
	    printf "%-80.80s\n", $info[5];                # Address
	}
    }
    
#=====================================================================
# Messages not for BSRN database (0003) 
#=====================================================================
    printf "*U0003\n";
    printf "%-80.80s\n", $message_not_for_bsrn_database;
#=====================================================================
# Station description (0004) 
#=====================================================================
    printf "*U0004\n";
    printf "%9s\n", $date_of_sta_descript_change;
    printf " %2d %2d\n", $surface_type, $topography_type;
    printf "%-80.80s\n", $sta_address;
    printf "%-20s %-20.20s\n", $sta_tel, $sta_fax;
    printf "%-15s %-50.50s\n", $sta_tcpip, $sta_email_address;
    printf " %7.3f %7.3f %4d %5s\n", $sta_lat, $sta_lon, $sta_alt, $SYNOP_ID;
    printf "%9s\n", $date_of_horizon_change;
    printf " %6s %6s %6s %6s %6s %6s %6s %6s %6s %6s %6s\n", $pr01, $pr02, $pr03, $pr04, $pr05, $pr06, $pr07, $pr08, $pr09, $pr10, $pr11;
    
#=====================================================================
# Radiosonde header (0005) 
#=====================================================================
    
    if ($site eq "dra") {
	my $site_type = uc($site_type);
	$path = "./Data/UpperAir/";
    } 
    
    my $date = shift(@dates_to_proc);
    unshift(@dates_to_proc,$date);
    my $yyyy = substr($date,0,4);
    my $yy   = substr($date,2,2);
    my $mm   = substr($date,4,2);
    my $days = days_in($yyyy, $mm);
    my $wild = "\*";
    
    if ($site_type eq "surfrad") {
	$flist = join ('',$path,$site,$yyyy,$mm,$wild,".snd");
    } else {
	print STDOUT ">>site_type is $site_type\n";
	die "Can't determine site_type $!\n";
    }
    
    open(FILE_LIST, "ls $flist |") 
	or die "Can't get sonde file listing: $!\n";
    
    @curfiles = <FILE_LIST>;
    chomp(@curfiles);
    close FILE_LIST;
    
    my $premm   = sprintf "%02d",$month - 1;
    my $preyy   = substr($year,2,2);
    my $preyyyy = substr($year,0,4);
    if ($premm <= 0) {
	$preyyyy = $preyyyy - 1;
	$preyy   = substr($preyyyy,2,2);
	$premm   = sprintf "%02d",12;
    }
    
    if ($site_type eq "surfrad") {
	$plist = join ('',$path,$site,$preyyyy,$premm,$wild,".snd");
    } 
    
    open(PRE_LIST, "ls $plist |") 
	or die "Can't get sonde file listing: $!\n";
    @prefiles = <PRE_LIST>;
    chomp(@prefiles);
    close PRE_LIST;
    
    @curfiles + 0;
    @prefiles + 0;
    $num_curfiles = scalar(@curfiles); # num of current month sonde files
    $num_prefiles = scalar(@prefiles); # num of previous month sonde files
    print STDOUT "--------------------------------------------------------------------------------\n";
    print STDOUT "This site ($site) has upper air data associated with it.  The data header file\n";
    print STDOUT "will be built depending on the number of radiosonde files in the current\n";
    print STDOUT "and previous month.\n\n";
    print STDOUT "Sonde files in current month:  $num_curfiles\n";
    print STDOUT "Sonde files in previous month: $num_prefiles\n";
#
# Based on the number of sonde files in the current and previous month,
# determines correct info for 0005 section.
#	
    if (($num_curfiles > 0) && ($num_prefiles > 0)) {
	$is_sonde_operating = "Y";
	$sonde_date_when_change = " -1 -1 -1";
    } elsif (($num_curfiles == 0) && ($num_prefiles == 0)) {
	$is_sonde_operating = "N";
	$sonde_date_when_change = " -1 -1 -1";
    } elsif (($num_curfiles == 0) && ($num_prefiles > 0)) {
	$is_sonde_operating = "N";
	$sonde_date_when_change = "  1  0  0";
    } elsif (($num_curfiles > 0) && ($num_prefiles == 0)) {
	$is_sonde_operating = "Y";
	my $first_file = shift(@curfiles);
	if ($site_type eq "surfrad") {
	    my $dd = substr($first_file,-10,2);
	    my $hh = substr($first_file,-8,2);
	    my $mm = substr($first_file,-6,2);
	    $sonde_date_when_change = sprintf" %2d %2d %2d", $dd,$hh,$mm;
	} else {
	    die "Can't determine site_type $site_type";
	}
    }
    
    if ($site eq "dra") {
	$sonde_manufacturer = "VIZ/Sippican";
	$location = "Desert Rock, NV";
	$distance_from_rad_site = 0;
	$time_1st_launch = 00;
	$time_2nd_launch = 12;
	$time_3rd_launch = -1;
	$time_4th_launch = -1;
	$sonde_id = "72387";
	$sonde_remarks = "If launch time is exactly 00Z or 12Z, the actual launch time is likely unknown";
    } 
    printf "*U0005\n";
    printf "%9s %1s\n", $sonde_date_when_change, $is_sonde_operating;
    printf "%-30.30s %-25.25s %3d %2d %2d %2d %2d %5s\n", $sonde_manufacturer,
    $location, $distance_from_rad_site, $time_1st_launch, $time_2nd_launch,
    $time_3rd_launch, $time_4th_launch, $sonde_id;
    printf "%-80.80s\n", $sonde_remarks;
    
#=====================================================================
# Station history (0007) 
#=====================================================================
    printf "*U0007\n";
    printf "%9s\n", $date_of_sta_history_change;
    printf "%-80.80s\n", $method_est_cloud_amount;
    printf "%-80.80s\n", $method_est_cloud_base;
    printf "%-80.80s\n", $method_est_water_content;
    printf "%-80.80s\n", $method_est_aero_vert_dist;
    printf "%-80.80s\n", $method_est_water_vap_pres;
    printf "%11s\n", $flags_if_the_above_five_are_measured;
    printf "*U0008\n";
}

#
# The following creates the 0001 section.  This is old code and 
# probably should be redone with printf statements above.
# 
format H1_FORMAT =
*U0001
 @< @< @<<< @>
 $sta_ID,$month,$year,$version_of_data
 @>>>>>>>> @>>>>>>>> @>>>>>>>> @>>>>>>>> @>>>>>>>> @>>>>>>>> @>>>>>>>> @>>>>>>>>
splice(@h2::mvkeylist, 0, 8);
~@>>>>>>>> @>>>>>>>> @>>>>>>>> @>>>>>>>> @>>>>>>>> @>>>>>>>> @>>>>>>>> @>>>>>>>>
splice(@h2::mvkeylist, 0, 8);
~@>>>>>>>> @>>>>>>>> @>>>>>>>> @>>>>>>>> @>>>>>>>> @>>>>>>>> @>>>>>>>> @>>>>>>>>
splice(@h2::mvkeylist, 0, 8);
.
1;
